DROP TABLE IF EXISTS `#__jr_tfb_answer`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_answer` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `answer_question` text NOT NULL,
  `answer_name` varchar(255) NOT NULL,
  `answer_title` text NOT NULL,
  `answer_desc` text NOT NULL,
  `answer_image` varchar(255) NOT NULL,
  `answer_image_type` int(1) NOT NULL DEFAULT '0',
  `answer_image_width` int(11) NOT NULL,
  `answer_image_height` int(11) NOT NULL,
  `answer_thumb_width` int(11) NOT NULL,
  `answer_thumb_height` int(11) NOT NULL,
  `answer_image_position` int(2) NOT NULL DEFAULT '0',
  `answer_image_title` varchar(255) NOT NULL,
  `answer_image_footer` varchar(255) NOT NULL,
  `answer_correct` int(1) NOT NULL DEFAULT '0',
  `answer_point` int(11) NOT NULL DEFAULT '0',
  `published` int(1) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_category`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_category` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `category_title` varchar(255) NOT NULL,
  `category_desc` text NOT NULL,
  `category_image` varchar(255) NOT NULL,
  `category_group` text NOT NULL,
  `published` int(1) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_form`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_form` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `form_test` text NOT NULL,
  `form_name` varchar(255) NOT NULL,
  `form_title` text NOT NULL,
  `form_desc` text NOT NULL,
  `form_required` int(1) NOT NULL DEFAULT '0',
  `form_check` int(2) NOT NULL DEFAULT '0',
  `form_rule` text NOT NULL,
  `form_message` text NOT NULL,
  `form_type` int(2) NOT NULL DEFAULT '0',
  `form_options` text NOT NULL,
  `form_search` int(1) NOT NULL DEFAULT '0',
  `form_access` int(1) NOT NULL DEFAULT '0',
  `published` int(1) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_group`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_group` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `group_test` text NOT NULL,
  `group_ref` int(11) NOT NULL DEFAULT '0',
  `group_name` varchar(255) NOT NULL,
  `group_title` text NOT NULL,
  `group_desc` text NOT NULL,
  `group_showtitle` int(1) NOT NULL DEFAULT '0',
  `group_showdesc` int(1) NOT NULL DEFAULT '0',
  `group_points` int(11) NOT NULL DEFAULT '0',
  `group_questions` int(11) NOT NULL DEFAULT '0',
  `group_select` int(1) NOT NULL DEFAULT '1',
  `group_back` int(1) NOT NULL DEFAULT '0',
  `published` int(1) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_question`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_question` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `question_group` text NOT NULL,
  `question_name` varchar(255) NOT NULL,
  `question_title` text NOT NULL,
  `question_desc` text NOT NULL,
  `question_image` varchar(255) NOT NULL,
  `question_image_type` int(1) NOT NULL,
  `question_image_width` int(11) NOT NULL,
  `question_image_height` int(11) NOT NULL,
  `question_thumb_width` int(11) NOT NULL,
  `question_thumb_height` int(11) NOT NULL,
  `question_image_position` int(2) NOT NULL DEFAULT '0',
  `question_required` int(1) NOT NULL DEFAULT '0',
  `question_answer` int(2) NOT NULL DEFAULT '0',
  `question_layout` text NOT NULL,
  `question_width` text NOT NULL,
  `question_select` int(1) NOT NULL,
  `question_correct` int(1) NOT NULL DEFAULT '0',
  `question_advice` text NOT NULL,
  `question_image_resize` int(11) NOT NULL DEFAULT '0',
  `question_answer_colums` int(11) NOT NULL DEFAULT '1',
  `published` int(1) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_result`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_result` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `result_test` int(11) NOT NULL,
  `result_user` int(11) NOT NULL,
  `result_client` int(11) NOT NULL,
  `result_result` int(1) NOT NULL,
  `result_point` int(11) NOT NULL,
  `result_points` int(11) NOT NULL,
  `result_points_group` int(11) NOT NULL DEFAULT '0',
  `result_points_group_id` int(11) NOT NULL DEFAULT '0',
  `result_scale` text NOT NULL,
  `result_advice` text NOT NULL,
  `result_timer` int(11) NOT NULL,
  `result_start` datetime NOT NULL,
  `result_date` datetime NOT NULL,
  `result_passed` int(1) NOT NULL DEFAULT '0',
  `result_verification` text NOT NULL,
  `result_check` text NOT NULL,
  `result_count_question` int(11) NOT NULL DEFAULT '0',
  `result_count_group` int(11) NOT NULL DEFAULT '0',
  `result_questions` text NOT NULL,
  `result_answers` text NOT NULL,
  `result_time` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_test`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_test` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `test_category` int(11) NOT NULL,
  `test_image` varchar(255) NOT NULL,
  `test_name` varchar(255) NOT NULL,
  `test_title` text NOT NULL,
  `test_desc` text NOT NULL,
  `test_showtitle` int(1) NOT NULL DEFAULT '1',
  `test_showdesc` int(1) NOT NULL DEFAULT '1',
  `test_access` int(1) NOT NULL DEFAULT '0',
  `test_login` int(11) NOT NULL DEFAULT '0',
  `test_password` int(11) NOT NULL DEFAULT '0',
  `test_verification` int(11) NOT NULL DEFAULT '0',
  `test_complete` int(11) NOT NULL DEFAULT '1',
  `test_failed` varchar(255) NOT NULL DEFAULT '1',
  `test_max_text` text NOT NULL,
  `test_delay` varchar(255) NOT NULL DEFAULT '1',
  `test_delay_text` text NOT NULL,
  `test_points` varchar(255) NOT NULL DEFAULT '0',
  `test_time` int(11) NOT NULL DEFAULT '0',
  `test_timer` int(1) NOT NULL DEFAULT '0',
  `test_timer_show` int(1) NOT NULL DEFAULT '0',
  `test_timer_text` text NOT NULL,
  `test_timer_point` int(11) NOT NULL DEFAULT '0',
  `test_timer_calc` int(1) NOT NULL DEFAULT '0',
  `test_timer_form` int(11) NOT NULL DEFAULT '0',
  `test_quantity` int(11) NOT NULL DEFAULT '1',
  `test_quantity_text` text NOT NULL,
  `test_n_message` text NOT NULL,
  `test_p_message` text NOT NULL,
  `test_l_message` text NOT NULL,
  `test_admin_group` int(11) NOT NULL,
  `test_admin` int(11) NOT NULL,
  `test_admin_email` varchar(255) NOT NULL,
  `test_client_subject` varchar(255) NOT NULL,
  `test_admin_subject` varchar(255) NOT NULL,
  `test_client_email_n` text NOT NULL,
  `test_client_email_p` text NOT NULL,
  `test_client_email_r` int(1) NOT NULL DEFAULT '0',
  `test_client_email_r_title` text NOT NULL,
  `test_admin_email_text` text NOT NULL,
  `test_client_send` int(1) NOT NULL DEFAULT '0',
  `test_admin_send` int(1) NOT NULL DEFAULT '0',
  `test_admin_details` int(1) NOT NULL DEFAULT '0',
  `test_client_details` int(1) NOT NULL DEFAULT '0',
  `test_client_mark` int(1) NOT NULL DEFAULT '0',
  `test_admin_mark` int(1) NOT NULL DEFAULT '0',
  `test_start` date NOT NULL,
  `test_end` date NOT NULL,
  `test_start_text` text NOT NULL,
  `test_end_text` text NOT NULL,
  `test_save` int(1) NOT NULL DEFAULT '0',
  `test_passed` int(11) NOT NULL DEFAULT '0',
  `test_poor` int(11) NOT NULL DEFAULT '0',
  `test_count` int(1) NOT NULL DEFAULT '0',
  `test_test` int(11) NOT NULL DEFAULT '0',
  `test_scale` text NOT NULL,
  `test_back` int(1) NOT NULL DEFAULT '0',
  `test_result_show` int(1) NOT NULL DEFAULT '0',
  `test_group` text NOT NULL,
  `test_group_positive` int(11) NOT NULL DEFAULT '0',
  `test_group_negative` int(11) NOT NULL DEFAULT '0',
  `test_admin_fields` text NOT NULL,
  `test_print_pdf_admin` int(1) NOT NULL DEFAULT '1',
  `test_print_pdf_client` int(1) NOT NULL DEFAULT '1',
  `test_result_show_time` int(1) NOT NULL DEFAULT '3',
  `test_result_show_date` int(1) NOT NULL DEFAULT '3',
  `test_result_show_points` int(1) NOT NULL DEFAULT '3',
  `test_result_show_scale` int(1) NOT NULL DEFAULT '3',
  `test_result_show_result` int(1) NOT NULL DEFAULT '3',
  `published` int(1) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `test_certificate_blank` text NOT NULL,
  `test_certificate_template` text NOT NULL,
  `test_certificate_condition` int(1) NOT NULL DEFAULT '0',
  `test_certificate_access` int(1) NOT NULL DEFAULT '3',
  `test_certificate_verification` int(1) NOT NULL DEFAULT '0',
  `test_certificate_valid` int(1) NOT NULL DEFAULT '0',
  `test_certificate_term` int(11) NOT NULL DEFAULT '0',
  `test_cost` int(11) NOT NULL DEFAULT '0',
   PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_user`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_user` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_user` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_version`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_version` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `version_relize` varchar(255) NOT NULL,
  `version_desc` text NOT NULL,
  `version_date` date NOT NULL,
  `version_update` date NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_access`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_access` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `access_test` int(11) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

DROP TABLE IF EXISTS `#__jr_tfb_plugins`;
CREATE TABLE IF NOT EXISTS `#__jr_tfb_plugins` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `plugins_file` varchar(255) NOT NULL,
  `plugins_name` varchar(255) NOT NULL,
  `plugins_desc` varchar(255) NOT NULL,
  `plugins_options_name` text NOT NULL,
  `plugins_options_type` text NOT NULL,
  `plugins_options_value_name` text NOT NULL,
  `plugins_options_value` text NOT NULL,
  `plugins_options_selected` text NOT NULL,
  `plugins_panel` int(1) NOT NULL DEFAULT '0',
  `published` int(1) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

INSERT INTO `#__jr_tfb_version` (
  `id`,
  `version_relize`,
  `version_desc`,
  `version_date`,
  `version_update`
) 
VALUES (
  1,
  '1.31',
  '- добавлена функция печати сертификата теста в формате PDF (требуется установка дополнительного расширения компонента)
  - добавлена опция настройки доступа к данным пользователя (ограничение доступа при общем просмотре и проверки сертификата)',
  '2021-04-17',
  '2021-04-17'
  );

