<?php

/**
 * Jr_tfb Model for Jr_tfb Component
 * 
 * @package    Jr_tfb
 * @subpackage com_jr_tfb
 * @license  GNU/GPL v2
 *
 * Created with Marco's Component Creator for Joomla! 2.5
 * http://www.mmleoni.net/joomla-component-builder
 *
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.modellist' );

/**
 * Jr_tfb Model
 *
 * @package    Joomla.Components
 * @subpackage 	Jr_tfb
 */
class Jr_tfbModelJrtfbformlist extends JModelList{

	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @return	void
	 * @since	1.6
	 */

	protected function populateState($ordering = null, $direction = null){
		parent::populateState($ordering, $direction);
		
		// Adjust the context to support modal layouts.
		if ($layout = JFactory::getApplication()->input->get('layout', '', 'CMD')) {
			$this->context .= '.'.$layout;
		}
		
		$filter_order = $this->getUserStateFromRequest($this->context . '.filter.ordering', 'filter_order', 'ordering');
		$this->setState('filter.ordering', $filter_order);
		
		$filter_order_Dir = strtoupper($this->getUserStateFromRequest($this->context . '.filter.direction', 'filter_order_Dir', 'ASC'));
		$this->setState('filter.direction', $filter_order_Dir);
		
		$search = $this->getUserStateFromRequest($this->context.'.filter.searchtest', 'filter_searchtest', '');
		$this->setState('filter.searchtest', $search);
	}

	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	private function _buildQuery(){
		// use alias t1 for easier JOINs writing
		$query = 'SELECT t1.* FROM `#__jr_tfb_form` t1 ' . $this->_buildQueryWhere() . $this->_buildQueryOrderBy();
		return $query;
	}

	/**
	 * Returns the 'order by' part of the query
	 * @return string the order by''  part of the query
	 */
	private function _buildQueryOrderBy() {
	    $app = JFactory::getApplication();

		// default field for records list
		$default_order_field = 'id'; 
		// Array of allowable order fields
	    $allowedOrders = explode(',', 'id,form_name,form_title,form_desc,form_required,form_check,form_rule,form_message,form_type,form_options,published,ordering'); // array('id', 'ordering', 'published'); 

		// retrive ordering info
		$filter_order = $this->getState('filter.ordering');
		$filter_order_Dir = strtoupper($this->getState('filter.direction'));

	    // validate the order direction, must be ASC or DESC
	    if ($filter_order_Dir != 'ASC' && $filter_order_Dir != 'DESC') {
			$filter_order_Dir = 'ASC';
	    }

	    // if order column is unknown use the default
	    if ((isSet($allowedOrders)) && !in_array($filter_order, $allowedOrders)){
			$filter_order = $default_order_field;
	    }
		// comment out if use switch
		$prefix = 't1'; 
		/*
		// strip comment if you use JOIN in select statement
		switch ($filter_order){
			case 'field1FromTable2':
			case 'field2FromTable2':
				$prefix = 't2';
				break;
			case 'field1FromOtherTable3':
				$prefix = 't3';
				break;
			default:
				$prefix = 't1';
				break;
		}
		*/

	    // return the ORDER BY clause        
	    return " ORDER BY {$prefix}.`{$filter_order}` {$filter_order_Dir}";
	}	
	private function _buildQueryWhere() {
	    $app = JFactory::getApplication();
	
		$searchtest = $this->getState('filter.searchtest');
		
	    if (!$searchtest OR $searchtest == 'all') return '';
		else if ($searchtest > 0) {
		$where = " WHERE t1.`form_test` LIKE '%|" . addSlashes($searchtest) . "|%' ";
		return $where;
		}
		else if ($searchtest == 'free') {
		$where = " WHERE t1.`form_test` = ''";
		return $where;
		}
	    
	}
	
	
	//j2.5 method
	protected function getListQuery(){
		//$db = JFactory::getDBO();
		$query = 'SELECT t1.* FROM `#__jr_tfb_form` t1 ' . $this->_buildQueryWhere() . $this->_buildQueryOrderBy();
		return $query;
	}
	
	/** OVERRIDE
	 * Retrieves the data
	 * @return array Array of objects containing the data from the database
	 
	public function getItems(){
		// Lets load the data if it doesn't already exist
		if (empty( $this->_data ))		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_data;
	}
	*/

	/** OVERRIDE ... FASTER!!! no join no sort!
	 * Gets the number of published records
	 * @return int
	 
	public function getTotal(){
		$db = JFactory::getDBO();
		$db->setQuery( 'SELECT COUNT(*) FROM `#__jr_tfb_form` t1 ' . $this->_buildQueryWhere() );
		return $db->loadResult();
	}
	*/
	
	
	/**
	 * Gets the Pagination Object
	 * @return object JPagination
	
	public function getPagination(){
		// Load the content if it doesn't already exist
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
	 */
	
	
	/**
	 * Methods to get records data for specific fields
	 * use returned recorset to populate view in specific
	 * select to manage related tables
	 * @return object list with options array
	 */
	
	public function getGenericFieldName($fieldName){
		$db = JFactory::getDBO();
		$db->setQuery( 'SELECT id AS value `$fieldName` AS text FROM `#__jr_tfb_form` ORDER BY `$fieldName`');
		$options = array();
		foreach( $db->loadObjectList() as $r){
			$options[] = JHTML::_('select.option',  $r->value, $r->text );
        }
		return $options;

	}
	
	

	
}