<?php
/**
 * Jr_tfb Model for Jr_tfb Component
 * 
 * @package    Jr_tfb
 * @subpackage com_jr_tfb
 * @license  GNU/GPL v2
 *
 * Created with Marco's Component Creator for Joomla! 2.5
 * http://www.mmleoni.net/joomla-component-builder
 *
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport('joomla.application.component.modeladmin');

/**
 * Jr_tfb Model
 *
 * @package    Joomla.Components
 * @subpackage 	Jr_tfb
 */
class Jr_tfbModelJrtfbtest extends JModelAdmin{
	/**
	 * Constructor that retrieves the ID from the request
	 *
	 * @access	public
	 * @return	void
	 */
	function __construct(){
		parent::__construct();

		//$array = JRequest::getVar('cid',  0, '', 'array');
		$array = JFactory::getApplication()->input->server->get('cid', 0, 'INT');
		$this->setId((int)$array[0]);
	}


	/**
	 * Method override to check if you can edit an existing record.
	 *
	 * @param	array	$data	An array of input data.
	 * @param	string	$key	The name of the key for the primary key.
	 *
	 * @return	boolean
	 * @since	1.6
	 */
	protected function allowEdit($data = array(), $key = 'id')
	{
		// Check specific edit permission then general edit permission.
		return JFactory::getUser()->authorise('core.edit', 'com_jr_tfb.jrtfbtest.'.((int) isset($data[$key]) ? $data[$key] : 0)) or parent::allowEdit($data, $key);
	}
	/**
	 * Returns a reference to the a Table object, always creating it.
	 *
	 * @param	type	The table type to instantiate
	 * @param	string	A prefix for the table class name. Optional.
	 * @param	array	Configuration array for model. Optional.
	 * @return	JTable	A database object
	 * @since	1.6
	 */
	public function getTable($type = 'Jrtfbtest', $prefix = 'Jr_tfbTable', $config = array()) 
	{
		return JTable::getInstance($type, $prefix, $config);
	}
	/**
	 * Method to get the record form.
	 *
	 * @param	array	$data		Data for the form.
	 * @param	boolean	$loadData	True if the form is to load its own data (default case), false if not.
	 * @return	mixed	A JForm object on success, false on failure
	 * @since	1.6
	 */
	public function getForm($data = array(), $loadData = true) 
	{
		// Get the form.
		$form = $this->loadForm('com_jr_tfb.jrtfbtest', 'jrtfbtest', array('control' => 'jform', 'load_data' => $loadData));
		if (empty($form)) 
		{
			return false;
		}
		return $form;
	}
	/**
	 * Method to get the script that have to be included on the form
	 *
	 * @return string	Script files
	 */
	public function getScript() 
	{
		return 'administrator/components/com_jr_tfb/models/forms/jrtfbtest.js';
	}
	/**
	 * Method to get the data that should be injected in the form.
	 *
	 * @return	mixed	The data for the form.
	 * @since	1.6
	 */
	protected function loadFormData() 
	{
		// Check the session for previously entered form data.
		$data = JFactory::getApplication()->getUserState('com_jr_tfb.edit.jrtfbtest.data', array());
		if (empty($data)) 
		{
			$data = $this->getItem();
		}
		if(isset($data->test_group) && !is_array($data->test_group)) $data->test_group=explode(',', $data->test_group);
		return $data;
	}
	
	
	/**
	 * Method to set the identifier for the record
	 *
	 * @access	public
	 * @param	int primary key identifier
	 * @return	void
	 */
	public function setId($id){
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}


	/**
	 * Methods to get options arrays for specific fields
	 * @return object with data
	 */
	
	public function &getGenericFieldName(){
		$options = array(
            JHTML::_('select.option',  'val1', 'text 1' ),
            JHTML::_('select.option',  'val2', 'text 2' )
        );    
		return $options;
	}
	
		public function save($data)
	{
			$id = (!empty($data['id'])) ? $data['id'] : (int) $this->getState('jrtfbtest.id');
		
		
		// Get a row instance.
		$table = $this->getTable();

		// Load the row if saving an existing item.
		if ($id > 0)
		{
			$table->load($id);
		}

		// Bind the data.
		if (!$table->bind($data))
		{
			$this->setError($table->getError());
			return false;
		}

		// Check the data.
		if (!$table->check())
		{
			$this->setError($table->getError());
			return false;
		}

		// Store the data.
		if (!$table->store())
		{
			$this->setError($table->getError());
			return false;
		}
		
// Create the row if saving non existing item.
if ($id == 0 AND empty($data['id'])) {
$db = JFactory::getDBO();
$select_entry = "SELECT `id` FROM `#__jr_tfb_test` ORDER BY `id` DESC LIMIT 0,1";
$db->setQuery($select_entry);
$last_row = $db->loadResult();

$insert_entry = "INSERT INTO `#__jr_tfb_access` (access_test) VALUES ($last_row)";
$db->setQuery($insert_entry);
$db->query();
		}
		
		$this->setState('jrtfbtest.id', $table->id);

		// Clean the cache
		$this->cleanCache();

		return true;
	}
	
}