<?php

/**
 * Jr_tfb Model for Jr_tfb Component
 * 
 * @package    Jr_tfb
 * @subpackage com_jr_tfb
 * @license  GNU/GPL v2
 *
 * Created with Marco's Component Creator for Joomla! 2.5
 * http://www.mmleoni.net/joomla-component-builder
 *
 */

defined( '_JEXEC' ) or die( 'Restricted access' );
jimport( 'joomla.application.component.modellist' );

/**
 * Jr_tfb Model
 *
 * @package    Joomla.Components
 * @subpackage 	Jr_tfb
 */
class Jr_tfbModelJrtfbtestlist extends JModelList{

	/**
	 * Method to auto-populate the model state.
	 *
	 * Note. Calling getState in this method will result in recursion.
	 *
	 * @return	void
	 * @since	1.6
	 */

	protected function populateState($ordering = null, $direction = null){
		parent::populateState($ordering, $direction);
		
		// Adjust the context to support modal layouts.
		if ($layout = JFactory::getApplication()->input->get('layout', '', 'CMD')) {
			$this->context .= '.'.$layout;
		}
		
		$filter_order = $this->getUserStateFromRequest($this->context . '.filter.ordering', 'filter_order', 'id');
		$this->setState('filter.ordering', $filter_order);
		
		$filter_order_Dir = strtoupper($this->getUserStateFromRequest($this->context . '.filter.direction', 'filter_order_Dir', 'ASC'));
		$this->setState('filter.direction', $filter_order_Dir);
		
		$search = $this->getUserStateFromRequest($this->context.'.filter.search', 'filter_search', '');
		$this->setState('filter.search', $search);
	}

	/**
	 * Returns the query
	 * @return string The query to be used to retrieve the rows from the database
	 */
	private function _buildQuery(){
		// use alias t1 for easier JOINs writing
		$query = 'SELECT t1.* FROM `#__jr_tfb_test` t1 ' . $this->_buildQueryWhere() . $this->_buildQueryOrderBy();
		return $query;
	}

	/**
	 * Returns the 'order by' part of the query
	 * @return string the order by''  part of the query
	 */
	private function _buildQueryOrderBy() {
	    $app = JFactory::getApplication();

		// default field for records list
		$default_order_field = 'id'; 
		// Array of allowable order fields
	    $allowedOrders = explode(',', 'id,test_category,test_image,test_name,test_title,test_desc,test_showtitle,test_showdesc,test_access,test_login,test_password,test_verification,test_complete,test_failed,test_max_text,test_delay,test_delay_text,test_points,test_time,test_timer,test_timer_show,test_timer_text,test_timer_point,test_timer_calc,test_timer_form,test_quantity,test_quantity_text,test_n_message,test_p_message,test_l_message,test_admin_group,test_admin,test_admin_email,test_client_subject,test_admin_subject,test_client_email_n,test_client_email_p,test_client_email_r,test_client_email_r_title,test_admin_email_text,test_client_send,test_admin_send,test_admin_details,test_client_details,test_client_mark,test_admin_mark,test_start,test_end,test_start_text,test_end_text,test_save,test_passed,test_poor,test_count,test_test,test_scale,test_back,published,ordering'); // array('id', 'ordering', 'published'); 

		// retrive ordering info
		$filter_order = $this->getState('filter.ordering');
		$filter_order_Dir = strtoupper($this->getState('filter.direction'));

	    // validate the order direction, must be ASC or DESC
	    if ($filter_order_Dir != 'ASC' && $filter_order_Dir != 'DESC') {
			$filter_order_Dir = 'ASC';
	    }

	    // if order column is unknown use the default
	    if ((isSet($allowedOrders)) && !in_array($filter_order, $allowedOrders)){
			$filter_order = $default_order_field;
	    }
		// comment out if use switch
		$prefix = 't1'; 
		/*
		// strip comment if you use JOIN in select statement
		switch ($filter_order){
			case 'field1FromTable2':
			case 'field2FromTable2':
				$prefix = 't2';
				break;
			case 'field1FromOtherTable3':
				$prefix = 't3';
				break;
			default:
				$prefix = 't1';
				break;
		}
		*/

	    // return the ORDER BY clause        
	    return " ORDER BY {$prefix}.`{$filter_order}` {$filter_order_Dir}";
	}	
	private function _buildQueryWhere() {
	    $app = JFactory::getApplication();
	
		$search = $this->getState('filter.search');
		
	    if (!$search) return '';
		
		$allowedSearch = explode(',', 'test_category,test_admin_email,test_client_subject,test_admin_subject'); // array('id', 'ordering', 'published'); 
		$where = ' WHERE (0=1) ';
		foreach($allowedSearch as $field){
			if (!$field) return '';
			$where .= " OR (t1.`$field` LIKE '%" . addSlashes($search) . "%') ";
		}
	    return $where;
	}
	
	
	//j2.5 method
	protected function getListQuery(){
		//$db = JFactory::getDBO();
		$query = 'SELECT t1.* FROM `#__jr_tfb_test` t1 ' . $this->_buildQueryWhere() . $this->_buildQueryOrderBy();
		return $query;
	}
	
	/** OVERRIDE
	 * Retrieves the data
	 * @return array Array of objects containing the data from the database
	 
	public function getItems(){
		// Lets load the data if it doesn't already exist
		if (empty( $this->_data ))		{
			$query = $this->_buildQuery();
			$this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
		}
		return $this->_data;
	}
	*/

	/** OVERRIDE ... FASTER!!! no join no sort!
	 * Gets the number of published records
	 * @return int
	 
	public function getTotal(){
		$db = JFactory::getDBO();
		$db->setQuery( 'SELECT COUNT(*) FROM `#__jr_tfb_test` t1 ' . $this->_buildQueryWhere() );
		return $db->loadResult();
	}
	*/
	
	
	/**
	 * Gets the Pagination Object
	 * @return object JPagination
	
	public function getPagination(){
		// Load the content if it doesn't already exist
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
	 */
	
	
	/**
	 * Methods to get records data for specific fields
	 * use returned recorset to populate view in specific
	 * select to manage related tables
	 * @return object list with options array
	 */
	
	public function getGenericFieldName($fieldName){
		$db = JFactory::getDBO();
		$db->setQuery( 'SELECT id AS value `$fieldName` AS text FROM `#__jr_tfb_test` ORDER BY `$fieldName`');
		$options = array();
		foreach( $db->loadObjectList() as $r){
			$options[] = JHTML::_('select.option',  $r->value, $r->text );
        }
		return $options;

	}
	
	

	
}