<?php
/**
 * Jr_tfb Model for Jr_tfb Component
 * 
 * @package    Jr_tfb
 * @subpackage com_jr_tfb
 * @license  GNU/GPL v2
 *
 * Created with Marco's Component Creator for Joomla! 1.6
 * http://www.mmleoni.net/joomla-component-builder
 *
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );

/**
 * Jr_tfb Model
 *
 * @package    Joomla.Components
 * @subpackage 	Jr_tfb
 */
class Jr_tfbModelJrtfbquestionlist extends JModelLegacy{
	
	/**
	 * Jrtfbquestionlist data array for tmp store
	 *
	 * @var array
	 */
	private $_data;

	/**
	* Pagination object
	* @var object
	*/
	private $_pagination = null;

	/*
	 * Constructor
	 *
	 */
	function __construct(){
		parent::__construct();

		$app = JFactory::getApplication();

        // Get pagination request variables
        $limit = $app->getUserStateFromRequest('global.list.limit', 'limit', $app->getCfg('list_limit'), 'int');
        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
 
        // In case limit has been changed, adjust it
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);
 
        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);

	}

	
	/**
	 * Gets the data
	 * @return mixed The data to be displayed to the user
	 */
	public function getData(){
		// Lets load the data if it doesn't already exist
		if (empty( $this->_data )){
			//$recordSet =& $this->getTable('jrtfbquestion');
			$db = JFactory::getDBO();
			// Get menu settings
			$app = JFactory::getApplication();
			$menuitem = $app->getMenu()->getActive(); // get the active item
			$params = $menuitem->params; // get the params
			$questions_categories = $params->get('jr_test_questions_category');
			$questions_tests = $params->get('jr_test_questions_test');
			$jr_test_questions_filter = $params->get('jr_test_questions_filter');
			$questions_question_filter = $params->get('jr_test_questions_question_filter');
			$questions_access = $params->get('jr_test_questions_access');
			$questions_category_list = "";
			$questions_test_list = "";
			$questions_group_list = "";
			$test_filter_questions = "";
			$questions_tests_list = '';
$session = JFactory::getSession();
// Get link
if (isset($_GET['limitstart']) OR isset($_GET['start'])) {
// get data from session
$questions_category_list = $session->get('questions_category_list');
$questions_test_list = $session->get('questions_test_list');
$test_filter_questions = $session->get('test_filter_questions');
}
else {
if (isset($_POST['category_filter'])) {
$questions_category_list = $_POST['category_filter'];
$session->set('questions_category_list',$questions_category_list);
}
else {
$questions_category_list = '';
$session->set('questions_category_list','');
}
if (isset($_POST['test_filter'])) {
$questions_test_list = $_POST['test_filter'];
$session->set('questions_test_list',$questions_test_list);
}
else {
$questions_test_list = '';
$session->set('questions_test_list','');
}
if (isset($_POST['test_filter_questions'])) {
$test_filter_questions = $_POST['test_filter_questions'];
$session->set('test_filter_questions',$test_filter_questions);
}
else {
$test_filter_questions = '';
$session->set('test_filter_questions','');
}
}
//------------------
// Get categories
if ($questions_category_list == "" AND $questions_categories != "") {
foreach ($questions_categories as $questions_category) {
if ($questions_category_list != "") $questions_category_list .= ",";
$questions_category_list .= $questions_category;
}
$questions_category_list_filter = " AND `test_category` IN ($questions_category_list)";
}
else if ($questions_category_list != "") $questions_category_list_filter = " AND `test_category` IN ($questions_category_list)";
else $questions_category_list_filter = "";
// Get tests
if ($questions_test_list == "" AND $questions_tests != "") {
foreach ($questions_tests as $questions_test) {
if ($questions_tests_list != "") $questions_tests_list .= ",";
$questions_tests_list .= $questions_test;
}
$questions_test_list_filter = " AND `id` IN ($questions_tests_list)";
}
else if ($questions_test_list != "") $questions_test_list_filter = " AND `id` IN ($questions_test_list)";
else $questions_test_list_filter = "";


// Start create test condition
$current_user = JFactory::getUser();
$current_user_id = $current_user->get('id');
$test_condition = "";
// passed
if ($questions_access == 2 AND $current_user_id > 0) {
$query = "SELECT DISTINCT `result_test` FROM `#__jr_tfb_result` where `result_passed` = 1 AND `result_result` = 2 AND `result_user` = ".$current_user_id;
$db->setQuery( $query );
$test_condition_list = $db->loadObjectList();
$test_condition_query = "";
foreach ($test_condition_list as $test_condition_item) {
if ($test_condition_query != "") $test_condition_query .= ",";
$test_condition_query .= $test_condition_item->result_test;
}
if ($test_condition_query != "") $test_condition = " AND `id` IN ($test_condition_query)";
else $test_condition = " AND `id` = 0";
}
// not passed
else if ($questions_access == 3 AND $current_user_id > 0) {
$query = "SELECT DISTINCT `result_test` FROM `#__jr_tfb_result` where `result_passed` = 0 AND `result_result` = 2 AND `result_user` = ".$current_user_id;
$db->setQuery( $query );
$test_condition_list = $db->loadObjectList();
$test_condition_query = "";
foreach ($test_condition_list as $test_condition_item) {
if ($test_condition_query != "") $test_condition_query .= ",";
$test_condition_query .= $test_condition_item->result_test;
}
if ($test_condition_query != "") $test_condition = " AND `id` IN ($test_condition_query)";
else $test_condition = " AND `id` = 0";
}
// not completed
else if ($questions_access == 4 AND $current_user_id > 0) {
$query = "SELECT DISTINCT `result_test` FROM `#__jr_tfb_result` where `result_result` = 1 AND `result_user` = ".$current_user_id;
$db->setQuery( $query );
$test_condition_list = $db->loadObjectList();
$test_condition_query = "";
foreach ($test_condition_list as $test_condition_item) {
if ($test_condition_query != "") $test_condition_query .= ",";
$test_condition_query .= $test_condition_item->result_test;
}
if ($test_condition_query != "") $test_condition = " AND `id` IN ($test_condition_query)";
else $test_condition = " AND `id` = 0";
}
//End create test condition


$query = "SELECT `id` FROM `#__jr_tfb_test` where `published` = 1".$questions_category_list_filter.$questions_test_list_filter.$test_condition;
$db->setQuery( $query );
$test_list = $db->loadObjectList();
$questions_tests_list = "";
foreach ($test_list as $test_list_item) {
if ($questions_tests_list != "") $questions_tests_list .= ",";
$questions_tests_list .= $test_list_item->id;
}
//------------------
			if ($questions_tests_list != "") {
			$query = "SELECT `group_test` FROM `#__jr_tfb_group` where `group_test` IN ($questions_tests_list)";
			$db->setQuery( $query );
			$groups = $db->loadObjectList();
			foreach ($groups as $group) {
			if ($questions_group_list != "") $questions_group_list .= ",";
			$questions_group_list .= $group->group_test;
			}
			}
	
			if ($test_filter_questions != "") $test_filter_questions = ' AND `question_title` LIKE "%'.$test_filter_questions.'%"';
			
			if ($questions_group_list != '') $query = 'SELECT * FROM `#__jr_tfb_question` WHERE `question_group` IN ('.$questions_group_list.')'.$test_filter_questions.' ORDER BY `id` ';
			else $query = 'SELECT * FROM `#__jr_tfb_question` WHERE `question_group` IN (0)'.$test_filter_questions.' ORDER BY `id` ';
			$this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_data;
	}

	/**
	 * Gets the number of published records
	 * @return int
	 */
	public function getTotal(){
	
			$db = JFactory::getDBO();
			// Get menu settings
			$app = JFactory::getApplication();
			$menuitem = $app->getMenu()->getActive(); // get the active item
			$params = $menuitem->params; // get the params
			$questions_categories = $params->get('jr_test_questions_category');
			$questions_tests = $params->get('jr_test_questions_test');
			$jr_test_questions_filter = $params->get('jr_test_questions_filter');
			$questions_question_filter = $params->get('jr_test_questions_question_filter');
			$questions_access = $params->get('jr_test_questions_access');
			$questions_category_list = "";
			$questions_test_list = "";
			$questions_group_list = "";
			$test_filter_questions = "";
			$questions_tests_list = '';
$session = JFactory::getSession();
// Get link
if (isset($_GET['limitstart']) OR isset($_GET['start'])) {
// get data from session
$questions_category_list = $session->get('questions_category_list');
$questions_test_list = $session->get('questions_test_list');
$test_filter_questions = $session->get('test_filter_questions');
}
else {
if (isset($_POST['category_filter'])) {
$questions_category_list = $_POST['category_filter'];
$session->set('questions_category_list',$questions_category_list);
}
else {
$questions_category_list = '';
$session->set('questions_category_list','');
}
if (isset($_POST['test_filter'])) {
$questions_test_list = $_POST['test_filter'];
$session->set('questions_test_list',$questions_test_list);
}
else {
$questions_test_list = '';
$session->set('questions_test_list','');
}
if (isset($_POST['test_filter_questions'])) {
$test_filter_questions = $_POST['test_filter_questions'];
$session->set('test_filter_questions',$test_filter_questions);
}
else {
$test_filter_questions = '';
$session->set('test_filter_questions','');
}
}
//------------------
// Get categories
if ($questions_category_list == "" AND $questions_categories != "") {
foreach ($questions_categories as $questions_category) {
if ($questions_category_list != "") $questions_category_list .= ",";
$questions_category_list .= $questions_category;
}
$questions_category_list_filter = " AND `test_category` IN ($questions_category_list)";
}
else if ($questions_category_list != "") $questions_category_list_filter = " AND `test_category` IN ($questions_category_list)";
else $questions_category_list_filter = "";
// Get tests
if ($questions_test_list == "" AND $questions_tests != "") {
foreach ($questions_tests as $questions_test) {
if ($questions_tests_list != "") $questions_tests_list .= ",";
$questions_tests_list .= $questions_test;
}
$questions_test_list_filter = " AND `id` IN ($questions_tests_list)";
}
else if ($questions_test_list != "") $questions_test_list_filter = " AND `id` IN ($questions_test_list)";
else $questions_test_list_filter = "";


// Start create test condition
$current_user = JFactory::getUser();
$current_user_id = $current_user->get('id');
$test_condition = "";
// passed
if ($questions_access == 2 AND $current_user_id > 0) {
$query = "SELECT DISTINCT `result_test` FROM `#__jr_tfb_result` where `result_passed` = 1 AND `result_result` = 2 AND `result_user` = ".$current_user_id;
$db->setQuery( $query );
$test_condition_list = $db->loadObjectList();
$test_condition_query = "";
foreach ($test_condition_list as $test_condition_item) {
if ($test_condition_query != "") $test_condition_query .= ",";
$test_condition_query .= $test_condition_item->result_test;
}
if ($test_condition_query != "") $test_condition = " AND `id` IN ($test_condition_query)";
else $test_condition = " AND `id` = 0";
}
// not passed
else if ($questions_access == 3 AND $current_user_id > 0) {
$query = "SELECT DISTINCT `result_test` FROM `#__jr_tfb_result` where `result_passed` = 0 AND `result_result` = 2 AND `result_user` = ".$current_user_id;
$db->setQuery( $query );
$test_condition_list = $db->loadObjectList();
$test_condition_query = "";
foreach ($test_condition_list as $test_condition_item) {
if ($test_condition_query != "") $test_condition_query .= ",";
$test_condition_query .= $test_condition_item->result_test;
}
if ($test_condition_query != "") $test_condition = " AND `id` IN ($test_condition_query)";
else $test_condition = " AND `id` = 0";
}
// not completed
else if ($questions_access == 4 AND $current_user_id > 0) {
$query = "SELECT DISTINCT `result_test` FROM `#__jr_tfb_result` where `result_result` = 1 AND `result_user` = ".$current_user_id;
$db->setQuery( $query );
$test_condition_list = $db->loadObjectList();
$test_condition_query = "";
foreach ($test_condition_list as $test_condition_item) {
if ($test_condition_query != "") $test_condition_query .= ",";
$test_condition_query .= $test_condition_item->result_test;
}
if ($test_condition_query != "") $test_condition = " AND `id` IN ($test_condition_query)";
else $test_condition = " AND `id` = 0";
}
//End create test condition


$query = "SELECT `id` FROM `#__jr_tfb_test` where `published` = 1".$questions_category_list_filter.$questions_test_list_filter.$test_condition;
$db->setQuery( $query );
$test_list = $db->loadObjectList();
$questions_tests_list = "";
foreach ($test_list as $test_list_item) {
if ($questions_tests_list != "") $questions_tests_list .= ",";
$questions_tests_list .= $test_list_item->id;
}
//------------------
			if ($questions_tests_list != "") {
			$query = "SELECT `group_test` FROM `#__jr_tfb_group` where `group_test` IN ($questions_tests_list)";
			$db->setQuery( $query );
			$groups = $db->loadObjectList();
			foreach ($groups as $group) {
			if ($questions_group_list != "") $questions_group_list .= ",";
			$questions_group_list .= $group->group_test;
			}
			}
	
			if ($test_filter_questions != "") $test_filter_questions = ' AND `question_title` LIKE "%'.$test_filter_questions.'%"';
			
		if ($questions_group_list != '') $db->setQuery( 'SELECT COUNT(*) FROM `#__jr_tfb_question` WHERE `question_group` IN ('.$questions_group_list.')'.$test_filter_questions );
		else $db->setQuery( 'SELECT COUNT(*) FROM `#__jr_tfb_question` WHERE `question_group` IN (0)'.$test_filter_questions );
		return $db->loadResult();
		
	}
	
	/**
	 * Gets the Pagination Object
	 * @return object JPagination
	 */
	public function getPagination(){
		// Load the content if it doesn't already exist
		if (empty($this->_pagination)) {
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination($this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}
		return $this->_pagination;
	}
	
	
}
